<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Procedure Iterators</TITLE>
<link href="suif1_108.html" rel=Next>
<link href="suif1_106.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_106.html">previous</A>, <A HREF="suif1_108.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC107" HREF="suif1_toc.html#TOC107">Procedure Iterators</A></H2>
<P>
<A NAME="IDX757"></A>
<A NAME="IDX758"></A>

</P>
<P>
<A NAME="IDX759"></A>
Most SUIF programs work on one procedure at a time.  These programs
require basically the same code to iterate through the file set entries
and procedures.  The <CODE>suif_proc_iter</CODE> routine is provided to handle
this common case.

</P>
<P>
Before calling the procedure iterator, you must initialize the SUIF
library (see section <A HREF="suif1_104.html#SEC104">Initialization and Finalization</A>), which also parses and removes some
standard options from the command-line arguments.  Either the SUIF
library's command-line parser (see section <A HREF="suif1_105.html#SEC105">Command-Line Parser</A>) or the
<CODE>getopt</CODE> function (from the standard C library) may be called
before the procedure iterator to parse command-line options not removed
by the library initialization.  The <CODE>suif_proc_iter</CODE> function then
reads the input and output file names from the command-line.  The first
file name on the command line is treated as an input file.  If the
<CODE>writeback</CODE> flag is set, the second file is treated as an output
file and any additional file names on the command line are alternately
treated as input and output files.  If the <CODE>writeback</CODE> flag is not
set, all the file names are treated as input files.

</P>
<P>
<A NAME="IDX760"></A>
The procedure bodies are then read one at a time and processed by a
user-specified function.  This function must be of the type
<CODE>prociter_f</CODE>, which takes a single <CODE>tree_proc</CODE> argument and
has a <CODE>void</CODE> return type.  When a procedure is read, the
<CODE>exp_trees</CODE> and <CODE>use_fortran_form</CODE> parameters are passed on to
the <CODE>read_proc</CODE> method for the <CODE>proc_sym</CODE>.  The
<CODE>exp_trees</CODE> argument specifies whether the procedure bodies are
converted to expression trees (see section <A HREF="suif1_31.html#SEC31">Expression Trees</A>), and the
<CODE>use_fortran_form</CODE> argument determines whether Fortran form is used
(see section <A HREF="suif1_89.html#SEC89">Features for Compiling Fortran</A>).  The defaults are to create expression trees but not
to use Fortran form.  If the <CODE>writeback</CODE> flag is set, the procedure
bodies are written to the output files after they have been processed.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_106.html">previous</A>, <A HREF="suif1_108.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
